#ifndef DATASET_H
#define DATASET_H

#include <vector>
#include <limits>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <iostream>
#include <fstream>

#define SAMPLES_MAX 10
#define TIMESERIES_MAX 20000

using namespace std;

class DataSet
{
public:
    DataSet();
    vector<double> originalTimeSeries[TIMESERIES_MAX];
    vector<double> perturbatedTimeSeries[TIMESERIES_MAX][SAMPLES_MAX];
    vector<double> perturbatedTimeSeriesStdDevs[TIMESERIES_MAX];

    void normalize(vector<double> & timeSeries);

    void printMeanVar(vector<double> &sequence);
    void perturbateNothing();
    void perturbateNormalMixed(double stddev0, double stddev1);
    void perturbateExponentialMixed(double stddev0, double stddev1);
    void perturbateUNEMixed(double stddev0, double stddev1);

    void perturbateUniform(double stddev = 1);
    void perturbateNormal(double stddev = 1);
    void perturbateExponential(double stddev = 1);

    void randomWalks(long n, long length);
    void readFromFile(const char *src);
    void writeMunich(const char *dst);
    void writeDust(const char *dst);

    void normalizePerturbatedTimeSeries();

    int N;
};

#endif // DATASET_H
