#ifndef PRECISIONRECALL_H
#define PRECISIONRECALL_H

#include <iostream>
#include <vector>
using namespace std;

#define TIMEVAL_SUB(a, b, result) \
do { \
 (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;          \
 (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;       \
 if ((result)->tv_usec < 0) {                           \
     --(result)->tv_sec;                                \
  (result)->tv_usec += 1000000;                         \
     }                                                  \
} while (0)


class PrecisionRecallM
{
public:
    PrecisionRecallM(const char *s);

    void addStartTime();
    void addStopTime();
    void add(vector<int> &exact, vector<int> &estimate);
    double getPrecision();
    double getRecall();
    double getF1();
    double getTime();

    void print();

    double n;
    double precision;
    double recall;
    double size;
    double t;
    double tn;
    const char *s;

    struct timeval begin;

};

#endif // PRECISIONRECALL_H
