/*
 * DataReader.h
 *
 *  Created on: Apr 8, 2011
 *      Author: besa
 */

#ifndef DATAREADER_H_
#define DATAREADER_H_
#include <string>
#include <iostream>
#include <vector>
#include <map>
#include <dirent.h>
#include <errno.h>
#include <sys/types.h>
using namespace std;

class DataReader {
public:
	string DATA_PATH;
	string QUERY_PATH;
	int COLLECTION_SIZE;
	int LENGTH;
public:
	typedef std::vector<double> TimeSlotType;
	typedef std::vector<TimeSlotType> UncertainSeriesType;
	typedef std::map<string, UncertainSeriesType> SeriesMapType;
	SeriesMapType series;
	UncertainSeriesType query;
	DataReader();
	DataReader(string file, int collectionLength, int tsLength);
	virtual ~DataReader();
	void read(int noSamples);
	void print();
};

#endif /* DATAREADER_H_ */
