/*
 * Kmeans.cpp
 *
 *  Created on: Apr 20, 2011
 *      Author: besa
 */

#include "Kmeans.h"
#include <boost/random/uniform_int.hpp>
#include <boost/random/variate_generator.hpp>
#include <boost/random.hpp>
using namespace boost;
using namespace std;
boost::mt19937 generator;

Kmeans::Kmeans() {
	// TODO Auto-generated constructor stub

}

Kmeans::Kmeans(int kvalue) {
//	this->k = kvalue;
	this->k = 3;
}

Kmeans::~Kmeans() {
	// TODO Auto-generated destructor stub
}

void Kmeans::cluster()
{
	this->clusters.clear();
	int range = this->data.size();
	uniform_int<> ur(0, range - 1);
	variate_generator<mt19937&,uniform_int<> > drawSample(generator, ur);
	vector<unsigned int> processed;
	vector<int> mapping;
	vector<double> centroids;
	for (int i = 0; i < range; i++)
		mapping.push_back(-1);
	int drawnSamples = 0;
	while (drawnSamples < this->k)
	{
                unsigned int drawnIndex = drawSample();
		int exists = std::find(processed.begin(), processed.end(), drawnIndex)!=processed.end();
		if (exists == 1)
		{
			continue;
		}
		processed.push_back(drawnIndex);
		mapping[drawnIndex] = drawnSamples;

		centroids.push_back(this->data[drawnIndex]);
		drawnSamples++;
		DataReader::TimeSlotType cluster;
		this->clusters.push_back(cluster);
	}
	bool end = true;

	do
	{
//		for (unsigned int i = 0; i < this->data.size(); i++)
//			cout << this->data[i] << "\t" << mapping[i] << endl;
//		for (unsigned int j = 0; j < centroids.size(); j++)
//			cout << centroids[j] << " ";
//		cout << endl << endl;
		end = true;
		for (unsigned int i = 0; i < this->data.size(); i++)
		{
			double min_distance = 10000;
			int closest_centroid_index = -1;
			for (unsigned int j = 0; j < centroids.size(); j++)
			{
				double distance = std::abs(centroids[j] - data[i]);
				if (distance < min_distance)
				{
					min_distance = distance;
					closest_centroid_index = j;
				}
			}
			if (mapping[i] != closest_centroid_index)
			{
				mapping[i] = closest_centroid_index;
				end = false;
			}
		}
		//recalculate centroids
		for (unsigned int j = 0; j < centroids.size(); j++)
		{
			double new_centroid = 0;
			int points_in_cluster = 0;
			for (unsigned int i = 0; i < mapping.size(); i++)
			{
                                if ((unsigned int)mapping[i] == j)
				{
					new_centroid += this->data[i];
					points_in_cluster++;
				}
			}
			new_centroid = new_centroid / points_in_cluster;
			centroids[j] = new_centroid;
		}
	} while (!end);
	for (unsigned int i = 0; i < this->data.size(); i++)
		this->clusters[mapping[i]].push_back(data[i]);

	//print clusters
//	cout << endl;
//	for (unsigned int i = 0; i < this->clusters.size(); i++)
//	{
//		for (unsigned int j = 0; j < this->clusters[i].size(); j++)
//			cout << i << " " << this->clusters[i][j] << endl;
//	}
}

