/*
 * GroundTruthCalculator.cpp
 *
 *  Created on: May 14, 2011
 *      Author: besa
 */

#include "GroundTruthCalculator.h"
#include "timeseries.h"
#include "timeseriescollection.h"
#include "common.h"

#include <dirent.h>
#include <iostream>
#include <fstream>
#include <fstream>
#include <iostream>
#include <boost/algorithm/string.hpp>
#include <string>
#include "math.h"
#include <sys/types.h>



using namespace std;
using namespace boost;

GroundTruthCalculator::GroundTruthCalculator() {
	// TODO Auto-generated constructor stub

}

GroundTruthCalculator::~GroundTruthCalculator() {
	// TODO Auto-generated destructor stub
}

void GroundTruthCalculator::calculate()
{
	string read_foldername = "/Users/besa/Thesis/temp/";
	string write_foldername = "/Users/besa/Thesis/EuclideanShort/";
	vector<string> folders = vector<string>();
	getdir(read_foldername.c_str(), folders);
	for(unsigned int f = 0; f < folders.size(); f++)
	{
		string read_filename = read_foldername + folders[f] + "/" + folders[f] + "_dust_normal_0.2_.dat";
		string write_filename = write_foldername + "euclidean_" + folders[f] + ".dat";
		cout << read_filename << endl;
		cout << folders[f] << endl;
		TimeSeriesCollection db(read_filename.c_str(), 1);
		this->collection = db;
		ofstream result_file;
		result_file.open (write_filename.c_str());
		int noSeries = db.sequences.size();
		for(int i = 0; i < noSeries; i++)
		{
			for(int j = 0; j < noSeries; j++)
			{
				double distance = this->euclidean(i, j);
				result_file << distance << " ";
			}
			result_file << endl;
		}
		result_file.close();
	}
}

double GroundTruthCalculator::euclidean(int q, int s)
{
//    int length = this->collection.sequences[0].sequence.size();
    int length = 8;
    double sum = 0.0;
	for(int i = 0; i < length; i++)
	{
		double diff = this->collection.sequences[q].sequence[i].groundtruth -
				this->collection.sequences[s].sequence[i].groundtruth;
		sum += diff * diff;
	}
	return sqrt(sum);
}

int GroundTruthCalculator::getdir (string dir, vector<string> &files)
{
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) {
        cout << "Error opening " << dir << endl;
        return 1;
    }
    while ((dirp = readdir(dp)) != NULL) {
    	string name;
    	name.assign(dirp->d_name);
    	if (name != ".." && name != "." && name != ".svn" && name != ".DS_Store")
    		files.push_back(string(dirp->d_name));
    }
    closedir(dp);
    return 0;
}



