/*
 * PrecisionRecall.h
 *
 *  Created on: May 14, 2011
 *      Author: besa
 */

#ifndef PRECISIONRECALL_H_
#define PRECISIONRECALL_H_
#include <string>
#include <fstream>
#include <vector>

using namespace std;

class PrecisionRecall {
public:
	PrecisionRecall(int n, double r_value,
			string resultPath, string groundTruth);
	PrecisionRecall();
	virtual ~PrecisionRecall();
	string  RESULT_PATH;
	string GROUND_TRUTH_EUCLIDEAN;
	string OUTPUT_PATH;
	int noSeries;
	double r;
	double tao;
	vector< vector<int> > euclidean_matrix;
	void calculate();
	void read_ground_truth();
	class Search_predicate {
	public:
		int value;
		bool operator() (const int& el)
		{
			return el == value;
		}
	};
	double precision;
	double recall;
	double f1;
	void average();
	struct Set
	{
		double Precision;
		double Recall;
		double F1;
	};
	typedef vector<Set> PrecisionVector;
	vector<string> initDatasets();
	void write_average(vector<PrecisionVector> all);
	void average_fixed_variance();
	void write_average_fixed_variance(vector<PrecisionVector> all);
};

#endif /* PRECISIONRECALL_H_ */
